# -*- coding: utf-8 -*-
import sys
from PyQt5.QtWidgets import *
from PyQt5 import uic, QtCore, QtGui, QtWidgets
import os
import time
from PyQt5.QtGui import *

import ftplib
from ftplib import FTP
from ftplib import error_perm

form_class = uic.loadUiType("1.FTPClient2_C.ui")[0]

class FTPClass():
    __instance = None

    @staticmethod
    def tea():
        if not FTPClass.__instance:
            raise Exception("FTPClass를 먼저 인스턴스화 해야 합니다.")
        return FTPClass.__instance

    @staticmethod
    def reset():
        FTPClass.__instance = None

    def __init__(self, banana):
        if FTPClass.__instance:
            raise Exception("인스턴스가 이미 존재합니다.")
        FTPClass.__instance = banana


class LoginWindow(QtWidgets.QMainWindow, form_class):
    def __init__(self):
        super().__init__()
        self.setFixedSize(820,900)
        self.setWindowIcon(QIcon("pagichacha.png"))
        self.setupUi(self)

        self.lineEdit_5.returnPressed.connect(self.ftpConnect)
        self.pushButton.clicked.connect(self.ftpConnect)


    def ftpConnect(self):
        global result

        HOST = self.lineEdit.text()
        ID = self.lineEdit_4.text()
        PW = self.lineEdit_5.text()
        # PORT = int(self.lineEdit_6.text())

        FTPClass.reset()
        ret = FTPClass(FTP(HOST))
        print(ret,"+++++++++++++++++ 1")

        FTPClass.tea().encoding = 'utf-8'
        result = FTPClass.tea().login(ID, PW)
        print(result)

        if result and result.split(' ')[0] == '230':
            print("로그인 성공!!")
            # self.textEdit_2.setText(result+"로그인 성공!!")
            self.myWindow = MyWindow()
            self.myWindow.show()
            self.close()
        else:
            print("Something went wrong.")
            # self.textEdit_2.setText("로그인 실패!!!!, ID/PW 등을 정확히 입력했는지 확인해 보시기 바랍니다.!")


class MyWindow(QtWidgets.QMainWindow, form_class):
    def __init__(self):
        super().__init__()

        self.local_path =  None
        self.remote_path = None
        self.curr_local = None
        self.curr_remote = None

        self.setFixedSize(820,900)
        self.setWindowIcon(QIcon("pagichacha.png"))
        self.setupUi(self)

        if result and result.split(' ')[0] == '230':
            self.textEdit_2.setText(result+"로그인 성공!!")
        else:
            self.textEdit_2.setText(result+"로그인 실패!!")

        self.populate_local()
        self.populate_remote()

        self.doConnections()

    def tidy_up(self):
        self.label_8.show()
        # print(self.local_path,"++++ 1")
        self.pushButton_12.hide()
        # print(self.local_path,"++++ 1")
        self.lineEdit_3.hide()
        # print(self.local_path,"++++ 1")
        self.label_8.setText('Ready.')


    def doConnections(self):
        self.pushButton_3.clicked.connect(self.retr)
        self.pushButton_2.clicked.connect(self.stor)

        # 리모트 명령
        # self.pushButton_4.clicked.connect(self.rnfr_rnto)

        self.pushButton_16.clicked.connect(self.remote_enter)
        self.pushButton_15.clicked.connect(self.remote_up)


    def remote_enter(self):
        self.tidy_up()
        if self.curr_remote:
            FTPClass.tea().cwd(os.path.join(self.remote_path, self.curr_remote))
            # print(FTPClass.tea().cwd(os.path.join(self.remote_path, self.curr_remote)))
            self.remote_path2 = FTPClass.tea().pwd()
            self.label_8.setText("현재 위치(리모트): "+self.remote_path2)
            print(self.remote_path, self.curr_remote,"++++ 16")
            self.populate_remote()
            self.curr_remote = None
        else:
            self.label_8.setText("리모트 폴더 선택 후 '폴더진입->' 버튼을 클릭해 주시기 바랍니다.")

    def remote_up(self):
        self.tidy_up()
        # Waffle.tea().cwd((os.sep).join(self.remote_path.split(os.sep)[:-1]))
        FTPClass.tea().cwd('..')
        # print(os.sep, self.remote_path,"++++ 17")
        self.remote_path2 = FTPClass.tea().pwd()
        self.label_8.setText("현재 위치(리모트): "+self.remote_path2)
        self.populate_remote()


    # def rnfr_rnto(self):
    #     if self.curr_remote is not None:
    #         try: self.pushButton_12.clicked.disconnect()
    #         except: pass
    #         self.pushButton_12.clicked.connect(self.apply_rn)
    #         self.lineEdit_3.show()
    #         self.pushButton_12.show()
    #         self.label_8.hide()
    #     else:
    #         self.label_8.setText("리모트 사이트의 파일을 선택 하셔야 합니다.")

    # def apply_rn(self):
    #     new_name = self.lineEdit_3.text()
    #     if new_name != '':
    #         try:
    #             r = FTPClass.tea().rename(self.curr_remote, new_name)
    #             self.tidy_up()
    #             self.label_8.setText(r + ': ' + new_name)
    #             self.populate_remote()
    #         except error_perm:
    #             self.label_8.setText("서버쪽 권한 관련 에러가 발생하였습니다. 권한 부분을 확인해 주시기 바랍니다.")
    #         except:
    #             self.label_8.setText("폴더가 아닌 파일을 선택해야 합니다.")
    #             import traceback
    #             traceback.print_exc()
    #     else:
    #         self.tidy_up()
    #         self.label_8.setText("리모트 파일의 변경할 이름을 입력해야 합니다.")


    def retr(self): 
        self.tidy_up()
        print(self.curr_remote,"++++ 18")
        if self.curr_remote is not None:
            try:
                r = FTPClass.tea().retrbinary('RETR' + ' ' + self.curr_remote, open(self.curr_remote, 'wb').write)
                print(r,"++++ 19")
                self.label_8.setText(r + ' ' + self.curr_remote)
            except:
                self.label_8.setText("폴더가 아닌 파일을 선택해야 합니다.")
                try:
                    os.remove(self.curr_remote)
                except:
                    pass
        else:
            self.label_8.setText("리모트 사이트의 파일을 선택한 후 '<='을 클릭하셔야 합니다.")

    def stor(self):
        self.tidy_up()
        print(self.curr_local,"++++ 20")
        if self.curr_local is not None:
            try:
                r = FTPClass.tea().storbinary('STOR ' + self.curr_local, open(self.curr_local, 'rb'))
                print(r,"++++ 21")
                self.label_8.setText(r + ' ' + self.curr_local)
                self.populate_remote()
            except error_perm:
                self.label_8.setText("서버쪽 권한 관련 에러가 발생하였습니다. 권한 부분을 확인해 주시기 바랍니다.")
            except:
                self.label_8.setText("폴더가 아닌 파일을 선택해야 합니다.")
                import traceback
                traceback.print_exc()
        else:
            self.label_8.setText("로컬 사이트의 파일을 선택한 후 '=>'을 클릭해야 합니다.")


    def populate_local(self):
        # self.tidy_up()
        self.local_path = os.getcwd() # 현재 디렉토리를 가져옴
        print(self.local_path,"++++ 1")
        self.fs_model = QtWidgets.QFileSystemModel() #파일시스템 모델의 객체 생성
        print(self.fs_model,"++++ 2")
        self.fs_model.setRootPath(self.local_path) # 현재 디렉토리를 루트로 설정
        print(self.fs_model.setRootPath(self.local_path),"++++ 3")
        self.treeView.setModel(self.fs_model) #트리뷰 설정
        print(self.treeView.setModel(self.fs_model),"++++ 4")
        self.treeView.setRootIndex(self.fs_model.index(self.local_path)) # 트리뷰의 루트를 현재 디렉토리로 지정
        print(self.treeView.setRootIndex(self.fs_model.index(self.local_path)),"++++ 5")
        print('local_path:', self.local_path)
        self.treeView.selectionModel().selectionChanged.connect(self.update_curr_local)


    def update_curr_local(self):
        # global curr_local
        self.tidy_up() # 화면 아래 레이블을 Ready로 바꿈
        try:
            index = self.treeView.selectedIndexes()[0]
            print(index,"++++ 6")
            # print(self.tree_l.selectedIndexes()[1],"++++ 6-1")
            self.curr_local = index.model().itemData(index).get(0) # 딕셔너리의 첫번째 값(선택한 폴더 또는 파일)
            print(index.model().itemData(index),"++++ 7")
            print('curr_local: ', self.curr_local)
        except:
            print("curr_local 변수에 로컬 파일이 선택되지 않았습니다.")
            self.curr_local = None
        return self.curr_local

    def populate_remote(self):
        self.remote_path = FTPClass.tea().pwd()
        print(self.remote_path,"++++ 8")
        remote_listing = FTPClass.tea().nlst()
        print(remote_listing,"++++ 9")
        self.dir_model = QtGui.QStandardItemModel()
        print(self.dir_model,"++++ 10")
        for ls in remote_listing:
            self.dir_model.appendRow(QtGui.QStandardItem(ls))
            # print(self.dir_model.appendRow(QtGui.QStandardItem(ls)),"++++ 11")
            # print(type(self.dir_model.appendRow(QtGui.QStandardItem(ls))),"++++ 11")
        self.listView.setModel(self.dir_model)
        print(self.listView.setModel(self.dir_model),"++++ 12")
        print('remote_path: ', self.remote_path)
        self.listView.selectionModel().selectionChanged.connect(self.update_curr_remote)

    def update_curr_remote(self):
        # global curr_remote
        self.tidy_up()
        try:
            index = self.listView.selectedIndexes()[0]
            print(index,"++++ 13")
            self.curr_remote = index.model().itemData(index).get(0)
            print(index.model().itemData(index),"++++ 14")
            print('curr_remote: ', self.curr_remote)
        except:
            print("curr_remote 변수에 리모트 파일이 선택되지 않았습니다.")
            self.curr_remote = None
        return self.curr_remote



app=QApplication(sys.argv)
# window = MyWindow()
window = LoginWindow()
window.show()
print("Before event loop")
app.exec_()
print("After event loop")
